// This program sends a file using UDT
// Usage: sendfile filename

#include <iostream>
#include <udt.h>

int main(int argc, char* argv[])
{
  if (sizeof(long long)!=8) {
    cout << "Error: sizeof(long long) must equal 8" << endl;
  }

   //usage: sendfile "filename"

   if (3 != argc)
   {
      cout << "usage: hserve filename filesize" << endl;
      return 0;
   }

   CUDT* recver = new CUDT;

   try
   {
      int port = recver->open(50001);
      cout << "hserve is ready at port: " << port << endl;

      recver->listen();
   }
   catch(CUDTException e)
   {
      cout << "error message: " << e.getErrorMessage();
      return 0;
   }


   //long long size;
   //size = 1131228;
   //try {
   //  recver->recv((char *)&size, 8);
   //}
   //catch (CUDTException e) {
   //  cout << "Error message: " << e.getErrorMessage();
   //}
   //cout << "About to receive file sized " << size << endl;

   ofstream ofs(argv[1]);

   try
   {
     recver->recvfile(ofs, 0, atoll(argv[2]));
//     recver->recvfile(ofs, 0, size);
   }
   catch(CUDTException e)
   {
      cout << "error message: " << e.getErrorMessage();
      return 0;
   }

   recver->close();
   delete recver;


   return 1;
}

